//
// History:
//
// 07/09/99 19:00 by Alexander Trush
// 03/02/00 18:00 by Alexander Trush
// 14/02/00 12:00 by Alexander Trush (new crc16() & isVarByte() )

// ToDo
// , ᫨  ᬥ饭  ᫮  ⮬  ,     ⥭ 塞
// , ᫨ 室  뤥 
// ஢ ஢ __ctype  㣨  DCB/DCD...

#include <idc.idc>

#define POLY 0x8408
/*
//                                      16   12   5
// this is the CCITT CRC 16 polynomial X  + X  + X  + 1.
// This works out to be 0x1021, but the way the algorithm works
// lets us use 0x8408 (the reverse of the bit pattern).  The high
// bit is always assumed to be set, thus we only use 16 bits to
// represent the 17 bit value.
*/

static crc16(f, l) {
  auto i;
  auto data, p;
  auto crc;

  if ( f >= l ) return 0;

  crc = 0xFFFF;
  do {
    data = Byte(f); f=f+1;
    for ( i=0; i < 8; i++ ) {
      if ( (crc ^ data) & 1 ) crc = (crc >> 1) ^ POLY;
                         else crc = (crc >> 1);
      data = data >> 1;
    }
  } while (f != l);

  crc =  ~crc;
  data = crc;
  crc = (crc << 8) | ((data >> 8) & 0xff);
  return (crc & 0xFFFF);
}



//
// 㭪   稭   f 稢 l
//

static OutZone(out, f, l) {

    auto a,c;

        for(a=f; a < l; a=a+1 ) {
           if(isVarByte(a)) {
                fprintf(out,"..");
           } else {
                fprintf(out,"%02X", Byte(a));
                c=c+1;
           }
        }
        return c;
}

//
// 㭪 ஢   ᢮⢮ _塞_
//
static isVarByte(addr) {

 auto cmdaddr, F;

        cmdaddr=addr & ~3;
        F=GetFlags(cmdaddr);
        return isUnknown(GetFlags(addr)) ||
               (F & MS_0TYPE)==FF_0OFF ||
               (F & MS_1TYPE)==FF_1OFF ||
               ( (GetOpType(cmdaddr,1)==2) && (addr&2) ) ||//  㧪  ⪨
               ( (GetOpType(cmdaddr,0)==7) && (addr&3) )   //  室
        ;
}
//
//
//

static main(void) {

 auto addr;
 auto startaddr, endaddr;
 auto borderCRCblock;
 auto SizeOfModule;
 auto ASUM;
 auto ConstantBytes;
 auto out, i;
 auto offset;
 auto name;

  Message("Generate PAT line\n");
  out=fopen("OUT_PAT.PAT", "at");
  fseek(out,0,2);  // 室   䠩

  if(SelStart()!=BADADDR) {
   if(!isVarByte(SelStart()) && Byte(SelStart())!=0) {
     SizeOfModule=SelEnd()-SelStart();
     if(SizeOfModule<32768) {

        // 뢮   ( 32-)
        startaddr=SelStart()+32;
        if(startaddr < SelEnd()) endaddr=startaddr; else endaddr=SelEnd();

        ConstantBytes=OutZone(out, SelStart(), endaddr);

        //  㫥  32  塞 ⮪ ਧ 饣  ".."
        for(addr=endaddr; addr < startaddr; addr=addr+1 ) {
           fprintf(out,"..");
        }


         //  ࢮ 饣 
        if(SelEnd()-startaddr>255) borderCRCblock=startaddr+255; else borderCRCblock=SelEnd();
        for(endaddr=startaddr; (!isVarByte(endaddr)) && (endaddr<borderCRCblock); endaddr=endaddr+1);


        ASUM=crc16(startaddr, endaddr);
        fprintf(out," %02X %04X %04X ", endaddr-startaddr, ASUM, SizeOfModule);

        //    
	for(i=SelStart(); i<SelEnd(); i=NextNotTail(i)) {

          if( hasName(GetFlags(i)) )
            {
                offset=i-SelStart();
          	fprintf(out,":%04X %s ", offset, Name(i) );
            }
        }

        //  ,    
	for(i=SelStart(); i<SelEnd(); i=NextNotTail(i)) {

          if(GetOpType(i,1)==2)
            {
                name=GetOpnd(i,1);
                name=substr(name,1,strlen(name)); //  ᨬ '='
                if(LocByName(name)!=BADADDR) {
                    offset=i-SelStart();
              	    fprintf(out,"^%04X %s ", offset, name );
                }
                continue;
            }

          if(GetOpType(i,0)==7)
            {
                name=GetOpnd(i,0);
                if(LocByName(name)!=BADADDR) {
                    offset=i-SelStart();
              	    fprintf(out,"^%04X %s ", offset, name );
                }
                continue;
            }

        }


        // 뢮 墮⮢ ⮢
        ConstantBytes=ConstantBytes+OutZone(out, endaddr, SelEnd());


        if(ConstantBytes<4) Message("\nWarning! Pattern is weak.");
        Message("\nDone.\n");

     } else Message("Error! Block too long.\n");
   } else Message("Error! Block must started with nozero and constant byte.\n");
  } else Message("Error! Select block first.\n");
fprintf(out,"\n");
}
